.\" gd_eof.3.  The gd_eof man page.
.\"
.\" Copyright (C) 2010, 2011, 2014 D. V. Wiebe
.\"
.\""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
.\"
.\" This file is part of the GetData project.
.\"
.\" Permission is granted to copy, distribute and/or modify this document
.\" under the terms of the GNU Free Documentation License, Version 1.2 or
.\" any later version published by the Free Software Foundation; with no
.\" Invariant Sections, with no Front-Cover Texts, and with no Back-Cover
.\" Texts.  A copy of the license is included in the `COPYING.DOC' file
.\" as part of this distribution.
.\"
.TH gd_eof 3 "16 October 2014" "Version 0.9.0" "GETDATA"
.SH NAME
gd_eof \(em report the number of samples in a dirfile field
.SH SYNOPSIS
.B #include <getdata.h>
.HP
.nh
.ad l
.BI "off_t gd_eof(DIRFILE *" dirfile ", const char *" field_code );
.hy
.ad n
.SH DESCRIPTION
The
.BR gd_eof ()
function queries a dirfile(5) database specified by
.I dirfile
and returns the sample number of the end-of-field marker for the vector field
given by
.IR field_code .
This is effectively the total number of samples available for the field,
including any frame offset.

The caller should not assume that this is equivalent (when accounting for the samples-per-frame of the indicated field) to the number of frames in the database
returned by
.BR gd_nframes (3),
nor even that the end-of-field marker falls on a frame boundary.

For a
.B RAW
field, the end-of-field marker occurs immediately after the last datum in the
data file associated with the field.  For other field types, the end-of-field
marker is equivalent to the end-of-field marker closest to the start of the
dirfile of any of the field inputs.  The special field
.I INDEX
has no end-of-field marker.

The end-of-field marker for a field containing no data is in the same location
as, or before, its beginning-of-field marker (see
.BR gd_bof (3)).
For a
.B RAW
field, the difference between the locations of the beginning- and end-of-field
markers indicates the number of samples of data actually stored on disk.

The 
.I dirfile
argument must point to a valid DIRFILE object previously created by a call to
.BR gd_open (3).

.SH RETURN VALUE
Upon successful completion,
.BR gd_eof ()
returns the sample number of the end-of-field marker for the indicated field.
On error, it returns -1 and sets the dirfile error to a non-zero error value.
Possible error values are:
.TP 8
.B GD_E_ALLOC
The library was unable to allocate memory.
.TP
.B GD_E_BAD_CODE
The field specified by
.I field_code
or one of the fields it uses as input was not found in the database.
.TP
.B GD_E_BAD_DIRFILE
The supplied dirfile was invalid.
.TP
.B GD_E_BAD_FIELD_TYPE
The location of the non-existent end-of-field marker for the special field
.I INDEX
was requested, possibly as a result of the field specified by
.I field_code
using
.I INDEX
as one of its inputs.
.TP
.B GD_E_DIMENSION
A scalar field was found where a vector field was expected in the definition
of
.I field_code 
or one of its inputs, or else
.I field_code
itself specified a scalar field.
.TP
.B GD_E_INTERNAL_ERROR
An internal error occurred in the library while trying to perform the task.
This indicates a bug in the library.  Please report the incident to the
GetData developers.
.TP
.B GD_E_IO
An attempt to
.BR stat (2)
the file associated with the field, or one of its input fields, failed.
.TP
.B GD_E_RECURSE_LEVEL
Too many levels of recursion were encountered while trying to resolve
.IR field_code .
This usually indicates a circular dependency in field specification in the
dirfile.
.TP
.B GD_E_UNKNOWN_ENCODING
The size of the decoded data file associated with the specified field or one of
its inputs could not be determined, because its encoding scheme was not
understood.
.TP
.B GD_E_UNSUPPORTED
The size of the decoded data file associated with the specified field or one of
its inputs could not be determined, because its encoding scheme was not
supported.
.PP
The dirfile error may be retrieved by calling
.BR gd_error (3).
A descriptive error string for the last error encountered can be obtained from
a call to
.BR gd_error_string (3).
.SH SEE ALSO
.BR dirfile (5),
.BR dirfile-encoding (5),
.BR gd_open (3),
.BR gd_bof (3),
.BR gd_error (3),
.BR gd_error_string (3),
.BR gd_nframes (3)
